<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2015 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Name: BBCode YouTube Video ColorBox
| Version: 2.0
| Filename: youtube_bbcode_include.php
| Author: Pisatel
| Support: http://www.meweb.ru/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
    if (!defined("IN_FUSION")) { die("Access Denied"); }
    unset($matches);
    preg_match_all("#\[youtube\](.*?)\[\/youtube\]#si", $text, $matches, PREG_PATTERN_ORDER);
    if (($cm = count($matches[0]))>0) {
// Settings
    $ycache = true; // on/off cache: true/false
    $ykey = "AIzaSyDXX-gRT3JDAwc25w3e_Q25Zwb6KkWrcoo"; // <- add your key
    $yprev = false; // preview: false (default) - 120px x 90px; true (medium) - 320px x 180px
// End settings
    add_to_head("<link rel='stylesheet' href='".INCLUDES."jquery/colorbox/colorbox.css' media='screen' />\n<link rel='stylesheet' href='".INCLUDES."bbcodes/youtube/youtube.css' media='screen' />\n".($ycache ? "<meta http-equiv='Cache-Control' content='max-age=30, must-revalidate' />\n" : "")."<script>
    $(function() {
    $('.yhead').on({ mouseenter: function() {
    $(this).data('focused','true');
    var link = $(this);
     if(link.data('focused') == 'true') {
    link.next('.ypopup').fadeIn('slow');
  }
},
    mouseleave: function() {
    $(this).data('focused','false');
    $('.ypopup').fadeOut('fast');
    $(this).siblings('.ypopup').hide();
     }
  });
});
</script>\n");
    add_to_footer("<script src='".INCLUDES."jquery/colorbox/jquery.colorbox.js'></script>
<script>
    $(function() {
     $('.youtube').colorbox({
     iframe:true,
     innerWidth:640,
     innerHeight:390
     });
 });
</script>\n");
    if (!function_exists('get_ydata')) {
    function get_ydata($url) {
    $ch = curl_init();
    $timeout = 5;
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    $data = curl_exec($ch);
    curl_close($ch);
    return $data;
  }
}
    if (!function_exists('getWord')){
    function getWord($number, $suffix){
    $keys = array(2, 0, 1, 1, 1, 2);
    $modern = $number % 100;
    $suffix_key = ($modern > 7 && $modern < 20) ? 2 : $keys[min($modern % 10, 5)];
    return $suffix[$suffix_key];
   }
}
    if (!function_exists('ctime')) {
    function ctime($ytime) {
    $start = new DateTime("@0");
    $start->add(new DateInterval($ytime));
    $stime = $start->format("H:i:s");
    $sc = explode(":", $stime);
    return $sc[0]*3600+$sc[1]*60+$sc[2];
  }
}
    for($i = 0; $i < $cm; $i++) {
    unset($youtube);
    $yurl = preg_replace("/(http(s)*:\/\/)*(www\.)*(youtube\.com\/watch\?v=|youtube\.com\/v\/|youtu\.be\/)*/si", "", trim($matches[1][$i]));
    $api = get_ydata("https://www.googleapis.com/youtube/v3/videos?id=".$yurl."&part=snippet%2Cstatistics%2CcontentDetails&key=".$ykey);
    $youtube = json_decode($api);
    if ($youtube && $youtube != NULL && $youtube->items) {
    foreach ($youtube->items as $item) {
    $published = $item->snippet->publishedAt;
    $title = $item->snippet->title;
    $description = $item->snippet->description;
    $thumb = $item->snippet->thumbnails;
    $author = $item->snippet->channelTitle;
    $duration = ctime($item->contentDetails->duration);
    $viewCount = $item->statistics->viewCount;
    $likes = $item->statistics->likeCount;
    $dislikes = $item->statistics->dislikeCount;
}
    $thumb = $yprev ? $thumb->medium->url : $thumb->default->url;
    $length_min = floor($duration / 60);
    $length_sec = $duration % 60;
    $min = getWord($length_min, $locale['arraymin']);
    $sec = getWord($length_sec, $locale['arraysec']);
    if ($likes == 0 && $dislikes > 0) {
    $rating = 0;
    $numRaters = $dislikes;
} elseif ($likes > 0 && $dislikes == 0) {
    $rating = 5;
    $numRaters = $likes;
} elseif ($likes > 0 && $dislikes > 0) {
    $numRaters = $likes + $dislikes;
    $rating = $likes * 5 / $numRaters;
} else {
    $rating = 0;
    $numRaters = 0;
}
    $golos = getWord($numRaters, $locale['arraygolos']);
    $title = iconv("UTF-8", "WINDOWS-1251//TRANSLIT", stripinput(trim((string)$title)));
    $description = !empty($description) ? iconv("UTF-8", "WINDOWS-1251//TRANSLIT", stripinput(trim((string)$description))) : $locale['nodesc'];
    $author = iconv("UTF-8", "WINDOWS-1251//TRANSLIT", stripinput(trim((string)$author)));
    $published = showdate("longdate", strtotime($published));
    $yinfo = "<strong>".$locale['zagolovok']."</strong><div class='ytc'><div class='yhead'>".$title."</div><div class='ypopup'>".$description."</div></div><br />";
   $yinfo .= "<strong>".$locale['avtor']."</strong>".$author.$locale['v200'].$published."<br />";
    $yinfo .= "<strong>".$locale['prosmotrov']."</strong>".number_format($viewCount, 0, ".", " ")."<br />";
    $yinfo .= "<strong>".$locale['prod']."</strong>".$length_min.$min.$length_sec.$sec."<br />";
    $yinfo .= "<strong>".$locale['rayting']."</strong>".($rating == 0 ? "0" : number_format($rating, 2, ",", " "))." (".$numRaters.$golos.")<i class='ytup'></i><span class='ygr'>".$likes."</span><i class='ytdown'></i><span class='yre'>".$dislikes."</span>";
    $yimg = "<div class='yplay ".($yprev ? "yplay_b" : "yplay_s")."'></div><a class='youtube' href='http://www.youtube.com/embed/".$yurl."?rel=0&amp;wmode=transparent' title='".$locale['bb_youtube'].$title."'><img src='".$thumb."' alt='".$locale['bb_youtube'].$title."' title='".$locale['bb_youtube'].$title."' class='tbl ypasp' /></a>";
} else {
    $yinfo = "<strong>".$locale['nodata']."</strong>";
    $title = $locale['nodata'];
    $yimg = "<img src='".INCLUDES."bbcodes/youtube/novideo.png' alt='".$locale['bb_youtube'].$title."' style='border:0' />";
}
    $text = preg_replace("#\[youtube\](.*?)\[\/youtube\]#si", "<strong>".$locale['bb_youtube']."</strong><div style='margin:3px; display:table; position:relative'>".$yimg."<div style='display:table-cell; padding-left:20px; vertical-align:top'>".$yinfo."</div></div>", $text, 1);
   }
}
?>